<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +--------------------------------------------------------------------+
// | The Lazym Project                                                  |
// +--------------------------------------------------------------------+
// | Copyright (c) 2004 ູѰ                                      |
// +--------------------------------------------------------------------+
// |  ҽ  Ͽ  LICENSE  LazyBoard ̼ |
// | 1.0   ֽϴ.  ̼    ּҿ  |
// | Ȯΰմϴ.                                                    |
// | http://www.lazybbs.net/license/korean__1_0.txt                     |
// | α׷̳ ̼   gonom9@gmail.com     |
// | Ͻðų http://www.lazybbs.net  湮Ͻñ ٶϴ.            |
// +--------------------------------------------------------------------+
//

/**
 * Debug class
 */
class Debug
{
	//{{{ Public property
	//}}}
	
	//{{{ Private property
	//}}}

	/**
	 * @access private
	 */
	function debug()
	{
		if (phpversion() < 5) {
			$this->__construct();
		}
	}
	 
	function __construct()
	{
	}
	
	function __destruct()
	{
	}
	
	function Free()
	{
		if (phpversion() < 5) {
			$this->__destruct();
		}
	}
	
	function &Singleton()
	{
		static $instance;

		if (!isset($instance)) $instance = new Debug;
		return $instance;
	}

	function show($var, $return=false)
	{
		$str = '';

		if (is_array($var)) {
			$str .= '<table border="1" class="LazymDebugTable">'."\n";
			$str .= '<tr><td colspan="2" align="center"><b>Array</b></td></tr>'."\n";
			foreach ($var as $k=>$v) {
				$str .= '<tr><td>'.$k.'</td><td>'.$this->show($v, true).'</td></tr>'."\n";
			}
			$str .= '</table>'."\n";
		} elseif(is_object($var)) {
			$str .= '<table border="1" class="LazymDebugTable">'."\n";
			$str .= '<tr><td colspan="2" align="center"><b>Object</b></td></tr>'."\n";
			$str .= '<tr><td>Variables</td><td>'.$this->show(get_object_vars($var), true).'</td></tr>'."\n";
			$str .= '<tr><td>Methods</td><td>'.$this->show(get_class_methods(get_class($var)), true).'</td></tr>'."\n";
			$str .= '</table>'."\n";
		} elseif (is_resource($var)) {
			$str .= '<div class="LazymDebugDIV">Resource : '.$var.'</div>';
		} elseif (is_bool($var)) {
			$str .= '<div class="LazymDebugDIV">'.($var?'TRUE':'FALSE').'</div>';
		} else {
			$str .= '<div class="LazymDebugDIV">'.preg_replace('/<br \/>/', '&crarr;<br \/>', nl2br(htmlspecialchars($var))).'</div>';
		}

		if ($return) return $str;
		else {
			$this->_header();
			echo $str;
		}
	}

	/**
	 * print header for css
	 */
	function _header()
	{
		static $printed = false;

		if (!$printed) {
			echo "<style>
		.LazymDebugTable {
			margin:5px;
			border-collapse:collapse;
			border-color:#CCCCCC;
		}
		.LazymDebugTable TD {
			font-size:9pt;
			padding:1px;
			padding-left:5px;
			padding-right:5px;
		}
		.LazymDebugDIV {
			font-size:9pt;
		}
		</style>";
		}
	}
}
?>